/*
	main.c - keygen library

	This file is part of stdhell.

	stdhell is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation, either version 3 of the License, or (at your
	option) any later version.

	stdhell is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
	for more details.

	You should have received a copy of the GNU General Public License
	along with stdhell. If not, see <https://www.gnu.org/licenses/>. 
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void
keygen_gen(int N)
{
	int c = 0;
	int randomizer = 0;

	srand((unsigned int)(time(NULL)));

	/* Characters to use for string generation */
	char numbers[] = "1234567890";
	char letter[] = "qwertyuiopasdfghjklzxcvbnm";
	char LETTER[] = "QWERTYUIOPASDFGHJKLZXCVBNM";
	char symbols[] = "!@#$%^&*?";

	/* Variable for each individual password character */
	char password[N];

	/* Completed password string */
	char complete_key[N];

	randomizer = rand() % 4;

	for (c = 0; c < N; c++) {
		switch (randomizer) {
		case 1:
			password[c] = numbers[rand() % 10];
			randomizer = rand() % 4;
			complete_key[c] = password[c];
			break;
		case 2:
			password[c] = symbols[rand() % 8];
			randomizer = rand() % 4;
			complete_key[c] = password[c];
			break;
		case 3:
			password[c] = LETTER[rand() % 26];
			randomizer = rand() % 4;
			complete_key[c] = password[c];
			break;
		default:
			password[c] = letter[rand() % 26];
			randomizer = rand() % 4;
			complete_key[c] = password[c];
		}
	}
	return 0;
}
